        program test
        dimension sp_f(3)
        common/electron/eil,esc,theta_e
 
        pi = acos(-1.0)       
        pm = 0.938279         
        dm = 1.875628 
        dtr = pi/180.
 
*     Initialization and definition of the type of the deuteron wave function
	icon = 0
        iw   = 3  !1 - Paris, 2 - V18 deuteron wave funcion, 3- cd Bonn, 4 - AV14
        call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &                iv1,iv2,isd,iw,ipp,ict,delta_m2,crs,ifl,q0)

*
**************************************
*       INPUT   PARAMETERS   
**************************************
        ei   = 11.00         ! initial electron energy
        pr   = 0.4           ! recoil nucleon momentum GeV/C
        thr0  = 70.          ! polar angle of the recoil nucleon vs q
        phir0 = 180.         ! azimuthal angle of the recoil nucleon
        ktf  = 1             ! the knock-out nucleon is proton(1), neutron(-1)
        noff = 1             ! Off-Shell effects included (1) not included (0)
        npv  = 0             ! only pole term in FSI (0), pole+PV (1) 
        npro = 1             ! (1) it calculates d\sigma/dE'_e d\Omega_e d\Omega_pf
                             ! (2)  ds/dE'd\Omega d\Omega_r
        icon = 0             ! 0-initialization, 1 - PWIA, 2 - forward rescattering,
                             ! 3- charge exchange rescattering 
                             ! 12 - PWIA+FSI, 13 - PWIA+CHEX, 123 - PWIA+FSI+CHEX
        isd  = 1             ! 1- spectatro mechanism when recoil is a sepctator
                             ! 2- direct mechanism, 0 - both
        ipp  = 0             ! S and D component in deuteron
        ict  = 0             ! no CT,  1 - quantum Difussion
        delta_m2 = 1.5       ! CT \Delta M parameter 
        q2 =   15.0              !Q2 virtuality of photon
                
*********************************************************************
*         fixing knock-out nucleons polarization axis along z
*********************************************************************
         sp_f(1) = 0.0; sp_f(2) = 0.0; sp_f(3) = 1.0

         do ithr = 10,180,5
         
         open(unit=15,file='kininput2.txt', status='unknown')
         
         do ikin = 1,1
         read(15,*,end=1)ei,ef,q2,xbj,pr,th_e,thq,qlab,omega,pf,thp,
     &    thpq,thnq
*         print *, ei,ef,q2,xbj,pr,th_e,thq,qlab,omega,pf,thp,thpq,thnq

	     thr0 = thnq
*         print *,thnq,ikin
*         thr0 = float(ithr)
         thr  = thr0*pi/180.0
         phir = phir0*pi/180.0
         
         alpha = (sqrt(pr**2 + pm**2) - pr*cos(thr))/pm
 
         icon=1                ! PWIA
        call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &               iv1,iv2,isd,iw,ipp,ict,delta_m2,crs0,ifl,q0)

 
 
**         iv1 = 3            ! FSI with diffractive parameterization for f_nn
**         iv2 = 10           ! Charge Exchange Gibbs_Luiseu parameterisation
**         icon=12!3          ! PWI+FSI !+CHEX

         
         icon = 12
         iv1  = 3
         iv2  = 10              !10021

		 ratio = 0.0
		 ratioct = 0.0
         do ict = 0,0
         call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &                 iv1,iv2,isd,iw,ipp,ict,delta_m2,crs12,ifl,q0)
        if(ifl.eq.1)goto 1      ! kinematically forbidden
        x = q2/(2.0*pm*q0)
        if(ict.eq.0)then
        ratio = 0
        if(crs0.ne.0.0)ratio=crs12/crs0
        else
        ratioct = 0
        if(crs0.ne.0.0)ratioct=crs12/crs0
        endif
        enddo
        
        tiv = 0.389385*1000.*1000.
        s = dm**2 + 2.0*dm*q0 - q2
        elab = (s-2.0*pm**2)/(2.0*pm)
        plab = sqrt(elab**2-pm**2)



        write(12,14)thr0,pr,ei,q2,x,plab,crs0,crs12,ratio
        
*        write(6,16)q2,pr,thr0,alpha,x,plab,crs0,crs12,
     &           ratio !,ratioct,ratioct/ratio
        print 16, ei,ef,q2,xbj,pr,th_e,thq,qlab,omega,pf,thp,thpq,thnq,
     & crs0,crs12,ratio

        enddo
        enddo
 14     format(5f8.3,2e11.3,f8.3)
16      format(13f8.3,2e11.3,f8.3)

1       continue
         
  	end






